﻿<ComClass(ComClass1.ClassId, ComClass1.InterfaceId, ComClass1.EventsId)> _
Public Class ComClass1

    Implements NavisworksIntegratedAPI9.InwPlugin

    Implements NavisworksIntegratedAPI9.InwExportPlugin

    Const DISPLAY_NAME = "COMAddIn"
    Const INTERNAL_NAME = "COMAddIn.ComClass1"

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "b2fd4fe0-6e5d-492f-bd48-60c3b98b6e7a"
    Public Const InterfaceId As String = "b718cbfa-b887-44b4-b27c-80e728a98d13"
    Public Const EventsId As String = "414b0c1e-e239-4030-8e21-33bd6a436851"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub

    Private m_plugin_site As NavisworksIntegratedAPI9.InwExportPlugin_Site



    Public Sub AdviseSite(ByVal plugin_site As NavisworksIntegratedAPI9.InwPlugin_Site) Implements NavisworksIntegratedAPI9.InwPlugin.AdviseSite
        m_plugin_site = plugin_site
    End Sub

    Public Function iActivate() As Boolean Implements NavisworksIntegratedAPI9.InwPlugin.iActivate
        iActivate = True
    End Function

    Public Sub iAppInitialising() Implements NavisworksIntegratedAPI9.InwPlugin.iAppInitialising

    End Sub

    Public Sub iAppTerminating() Implements NavisworksIntegratedAPI9.InwPlugin.iAppTerminating

    End Sub

    Public Function iDeactivate() As Boolean Implements NavisworksIntegratedAPI9.InwPlugin.iDeactivate
        iDeactivate = True
    End Function

    Public Sub iDoCustomOption() Implements NavisworksIntegratedAPI9.InwPlugin.iDoCustomOption

    End Sub

    Public Function iGetDisplayName() As String Implements NavisworksIntegratedAPI9.InwPlugin.iGetDisplayName
        iGetDisplayName = DISPLAY_NAME
    End Function

    Public Function iGetNumParameters() As Integer Implements NavisworksIntegratedAPI9.InwPlugin.iGetNumParameters
        iGetNumParameters = 0
    End Function

    Public Function iGetParameter(ByVal ndx As Integer, ByRef pData As Object) As String Implements NavisworksIntegratedAPI9.InwPlugin.iGetParameter
        iGetParameter = False
    End Function

    Public Function iSetParameter(ByVal ndx As Integer, ByVal newVal As Object) As Boolean Implements NavisworksIntegratedAPI9.InwPlugin.iSetParameter
        iSetParameter = False
    End Function

    Public Function iXtension(ByVal vIn As Object) As Object Implements NavisworksIntegratedAPI9.InwPlugin.iXtension
        iXtension = 0
    End Function

    Public ReadOnly Property ObjectName() As String Implements NavisworksIntegratedAPI9.InwPlugin.ObjectName
        Get
            ObjectName = INTERNAL_NAME
        End Get
    End Property

    Public Sub iBeginContext(ByVal p_state As NavisworksIntegratedAPI9.InwOpState) Implements NavisworksIntegratedAPI9.InwExportPlugin.iBeginContext

    End Sub

    Public Function iCanExport(ByVal p_state As NavisworksIntegratedAPI9.InwOpState, ByVal reason As Integer) As Boolean Implements NavisworksIntegratedAPI9.InwExportPlugin.iCanExport
        iCanExport = True
    End Function

    Public Function iDialog(ByVal p_state As NavisworksIntegratedAPI9.InwOpState, ByVal reason As Integer) As Boolean Implements NavisworksIntegratedAPI9.InwExportPlugin.iDialog
        iDialog = True
    End Function

    Public Sub iEndContext(ByVal p_state As NavisworksIntegratedAPI9.InwOpState) Implements NavisworksIntegratedAPI9.InwExportPlugin.iEndContext

    End Sub

    Public Function iExport(ByVal p_state As NavisworksIntegratedAPI9.InwOpState, ByVal reason As Integer, ByVal filename As String, ByVal Progress As NavisworksIntegratedAPI9.InwOpProgress) As NavisworksIntegratedAPI9.nwEExportStatus Implements NavisworksIntegratedAPI9.InwExportPlugin.iExport

        MsgBox("my COMAddIn plugin! Selected paths count:  " & p_state.CurrentSelection.Paths.Count)
        iExport = NavisworksIntegratedAPI9.nwEExportStatus.eExport_OK
    End Function

    Public Function iGetFormatName() As String Implements NavisworksIntegratedAPI9.InwExportPlugin.iGetFormatName
        iGetFormatName = ""
    End Function

    Public Function iGetFormatSuffix() As String Implements NavisworksIntegratedAPI9.InwExportPlugin.iGetFormatSuffix
        iGetFormatSuffix = ""
    End Function

    Public Function iGetUserString() As String Implements NavisworksIntegratedAPI9.InwExportPlugin.iGetUserString
        iGetUserString = DISPLAY_NAME
    End Function

    Public Function iHelpExport() As Boolean Implements NavisworksIntegratedAPI9.InwExportPlugin.iHelpExport
        iHelpExport = True
    End Function

    Public Sub InitialisePlugin(ByRef capbits As Integer, ByRef ver As Integer) Implements NavisworksIntegratedAPI9.InwExportPlugin.InitialisePlugin
        Dim bits As NavisworksIntegratedAPI9.nwECaps
        bits = NavisworksIntegratedAPI9.nwECaps.eCap_EXPORT_TOOL
        capbits = bits
        ver = 0
    End Sub

    Public Function iXtension1(ByVal vIn As Object) As Object Implements NavisworksIntegratedAPI9.InwExportPlugin.iXtension

    End Function

End Class


